Description: Improve compiler detection (cross compilation)
 XML-Bare fails to cross build from source, because it uses the build
 architecture compiler. The compiler detection in Makefile.PL just uses
 "gcc". This patch makes the CC configurable via environment and falls back
 to the detection mechanism of perl itself.
 .
 While this improves cross building, the patch will regress msvc builds as
 is, because earlier getcc used to return 0 for msvc and now it'll really
 return a compiler there. So the patch will work on Debian, but upstream may
 want to refine it.
Origin: vendor
Bug-Debian: https://bugs.debian.org/1069029
Author: Helmut Grohne <helmut@subdivi.de>
Reviewed-by: gregor herrmann <gregoa@debian.org>
Last-Update: 2024-05-15
Forwarded: https://rt.cpan.org/Ticket/Display.html?id=153513
Bug: https://rt.cpan.org/Ticket/Display.html?id=153513

--- a/Makefile.PL
+++ b/Makefile.PL
@@ -1,4 +1,5 @@
 #!/usr/bin/perl
+use Config;
 use ExtUtils::MakeMaker;
 require 5.006;
 my @basics = ( 
@@ -90,13 +91,8 @@
   );
 }
 sub getcc {
-  my $div = (substr($ENV{'PATH'},0,1) eq '/') ? ':' : ';';
-  my @path = split($div,$ENV{'PATH'});
-  foreach my $dir ( @path ) {
-    return 'gcc' if( -e "$dir/gcc" || -e "$dir/gcc.exe" ); # prefer gcc
-    return 'cc'  if( -e "$dir/cc"  || -e "$dir/cc.exe"  );
-  }               
-  return 0;
+  return $ENV{'CC'} if defined $ENV{'CC'};
+  return $Config::Config{cc};
 }
 
 # The following are hacks to force static linking and so remove need for msvcr## dll
